<template>
  <span class="v-icon" :class="[size, { left, right }]">
    <!-- <i :class="{ filled }">{{ name }}</i> -->
    <component v-if="customIconName" :is="customIconName" />
    <i v-else :class="{ filled }">{{ name }}</i>
  </span>
</template>

<script>
import CustomIconBurger from './custom-icons/burger.vue'
// import CustomIconClose from './custom-icons/close.vue'
import CustomIconFacebook from './custom-icons/facebook.vue'
import CustomIconYoutube from './custom-icons/youtube.vue'
import CustomIconLinkedin from './custom-icons/linkedin.vue'
import CustomIconTwitter from './custom-icons/twitter.vue'
import CustomIconInstagram from './custom-icons/instagram.vue'

export default {
  name: 'v-icon',
  components: {
    CustomIconBurger,
    // CustomIconClose,
    CustomIconFacebook,
    CustomIconTwitter,
    CustomIconLinkedin,
    CustomIconYoutube,
    CustomIconInstagram,
  },
  props: {
    name: {
      type: String,
      required: true,
    },
    filled: {
      type: Boolean,
      default: false,
    },
    sup: {
      type: Boolean,
      default: false,
    },
    left: {
      type: Boolean,
      default: false,
    },
    right: {
      type: Boolean,
      default: false,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    size: {
      type: String,
      required: false,
      validator: (val) =>
        ['sup', 'x-small', 'small', 'large', 'x-large'].includes(val),
    },
  },
  data() {
    return {
      customIcons: [
        'burger',
        // 'close',
        'linkedin',
        'facebook',
        'twitter',
        'youtube',
        'instagram',
      ],
    }
  },
  computed: {
    customIconName() {
      if (this.customIcons.includes(this.name))
        return `custom-icon-${this.name}`.replace(/_/g, '-')
      return null
    },
  },
  created() {},
  methods: {},
}
</script>

<style>
body {
  --v-icon-color: currentColor;
  --v-icon-color-hover: currentColor;
  --v-icon-size: 24px;
}
</style>

<style lang="scss" scoped>
.v-icon {
  @apply inline-block relative fill-current;
  width: var(--v-icon-size);
  min-width: var(--v-icon-size);
  height: var(--v-icon-size);
  font-size: 0;
  vertical-align: middle;
  i {
    display: block;
    font-weight: normal;
    font-size: var(--v-icon-size);
    /* stylelint-disable-next-line font-family-no-missing-generic-family-keyword */
    font-family: 'Material Icons Outline';

    font-style: normal;
    line-height: 1;
    letter-spacing: normal;
    white-space: nowrap;
    text-transform: none;
    word-wrap: normal;
    font-feature-settings: 'liga';
    &.filled {
      /* stylelint-disable-next-line font-family-no-missing-generic-family-keyword */
      font-family: 'Material Icons';
    }
    // font-family: 'Material Icons Outline';
  }

  &.sup {
    --v-icon-size: 8px;
    vertical-align: 5px;
  }
  &.x-small {
    --v-icon-size: 12px;
  }
  &.small {
    --v-icon-size: 18px;
  }
  &.large {
    --v-icon-size: 36px;
  }
  &.x-large {
    --v-icon-size: 48px;
  }
  &.left {
    margin-right: 8px;
    margin-left: 0px;
    &.small {
      margin-right: 4px;
      margin-left: 0px;
    }
  }
  &.right {
    margin-right: 0px;
    margin-left: 8px;
    &.small {
      margin-right: 4px;
      margin-left: 0px;
    }
  }
}
</style>
